searchData={"items":[{"type":"module","title":"educkdb","doc":"Low level erlang API for duckdb databases.","ref":"educkdb.html"},{"type":"function","title":"educkdb.append_boolean/2","doc":"Append a boolean value to the current location in the row.","ref":"educkdb.html#append_boolean/2"},{"type":"function","title":"educkdb.append_date/2","doc":"Append a data to the current location in the row.","ref":"educkdb.html#append_date/2"},{"type":"function","title":"educkdb.append_double/2","doc":"Append a double to the current location in the row. Note: duckdb double's are the same as erlang floats.","ref":"educkdb.html#append_double/2"},{"type":"function","title":"educkdb.append_float/2","doc":"Append a float to the current location in the row. Note: duckdb floats are different than erlang floats. When you add an erlang float to a duckdb float column, you will loose precision.","ref":"educkdb.html#append_float/2"},{"type":"function","title":"educkdb.append_int8/2","doc":"Append a tinyint to the current location in the row.","ref":"educkdb.html#append_int8/2"},{"type":"function","title":"educkdb.append_int16/2","doc":"Append a smallint to the current location in the row.","ref":"educkdb.html#append_int16/2"},{"type":"function","title":"educkdb.append_int32/2","doc":"Append an integer (32 bit) to the current location in the row.","ref":"educkdb.html#append_int32/2"},{"type":"function","title":"educkdb.append_int64/2","doc":"Append a bigint to the current location in the row.","ref":"educkdb.html#append_int64/2"},{"type":"function","title":"educkdb.append_null/1","doc":"Append a null value to the current location in the row.","ref":"educkdb.html#append_null/1"},{"type":"function","title":"educkdb.append_time/2","doc":"Append a time to the current location in the row.","ref":"educkdb.html#append_time/2"},{"type":"function","title":"educkdb.append_timestamp/2","doc":"Append a timestamp to the current location in the row.","ref":"educkdb.html#append_timestamp/2"},{"type":"function","title":"educkdb.append_uint8/2","doc":"Append a utinyint to the current location in the row.","ref":"educkdb.html#append_uint8/2"},{"type":"function","title":"educkdb.append_uint16/2","doc":"Append a usmallint to the current location in the row.","ref":"educkdb.html#append_uint16/2"},{"type":"function","title":"educkdb.append_uint32/2","doc":"Append an unsigned integer (32 bit) to the current location in the row.","ref":"educkdb.html#append_uint32/2"},{"type":"function","title":"educkdb.append_uint64/2","doc":"Append a ubigint to the current location in the row.","ref":"educkdb.html#append_uint64/2"},{"type":"function","title":"educkdb.append_varchar/2","doc":"Append a varchar to the current location in the row.","ref":"educkdb.html#append_varchar/2"},{"type":"function","title":"educkdb.appender_create/3","doc":"Create an appender. Appenders allow for high speed bulk insertions into the database. See DuckDB Appender for more information.","ref":"educkdb.html#appender_create/3"},{"type":"function","title":"educkdb.appender_end_row/1","doc":"Finalize the current row, and start a new one.","ref":"educkdb.html#appender_end_row/1"},{"type":"function","title":"educkdb.appender_flush/1","doc":"Flush the appender to the table, forcing the cache of the appender to be cleared and the data to be appended to the base table.","ref":"educkdb.html#appender_flush/1"},{"type":"function","title":"educkdb.bind_boolean/3","doc":"Bind a boolean to the prepared statement at the specified index.","ref":"educkdb.html#bind_boolean/3"},{"type":"function","title":"educkdb.bind_date/3","doc":"Bind a date to the prepared statement at the specified index. The date can be either given as a calendar:date() tuple, or an integer with the number of days since the first of January in the year 0.","ref":"educkdb.html#bind_date/3"},{"type":"function","title":"educkdb.bind_double/3","doc":"Bind an uint64 to the prepared statement at the specified index. Note: Erlang's float datatype is a DuckDB double. Using this function allows you to keep the precision.","ref":"educkdb.html#bind_double/3"},{"type":"function","title":"educkdb.bind_float/3","doc":"Bind an float to the prepared statement at the specified index. Note: Erlang's float() datatype is actually a DuckDB double. When binding an Erlang float variable you will lose precision.","ref":"educkdb.html#bind_float/3"},{"type":"function","title":"educkdb.bind_int8/3","doc":"Bind an int8 to the prepared statement at the specified index.","ref":"educkdb.html#bind_int8/3"},{"type":"function","title":"educkdb.bind_int16/3","doc":"Bind an int16 to the prepared statement at the specified index.","ref":"educkdb.html#bind_int16/3"},{"type":"function","title":"educkdb.bind_int32/3","doc":"Bind an int32 to the prepared statement at the specified index.","ref":"educkdb.html#bind_int32/3"},{"type":"function","title":"educkdb.bind_int64/3","doc":"Bind an int64 to the prepared statement at the specified index.","ref":"educkdb.html#bind_int64/3"},{"type":"function","title":"educkdb.bind_null/2","doc":"Bind a null value to the prepared statement at the specified index.","ref":"educkdb.html#bind_null/2"},{"type":"function","title":"educkdb.bind_time/3","doc":"Bind a time to the prepared statement at the specified index. The time can be either given as an {hour, minute, second} tuple (similar to calendar:time()), or as an integer with the number of microseconds since midnight.","ref":"educkdb.html#bind_time/3"},{"type":"function","title":"educkdb.bind_timestamp/3","doc":"Bind a timestamp to the prepared statement at the specified index. The timestamp can be either a datetime tuple, or an integer with the microseconds since 1-Jan in the year 0.","ref":"educkdb.html#bind_timestamp/3"},{"type":"function","title":"educkdb.bind_uint8/3","doc":"Bind an uint8 to the prepared statement at the specified index.","ref":"educkdb.html#bind_uint8/3"},{"type":"function","title":"educkdb.bind_uint16/3","doc":"Bind an uint8 to the prepared statement at the specified index.","ref":"educkdb.html#bind_uint16/3"},{"type":"function","title":"educkdb.bind_uint32/3","doc":"Bind an uint32 to the prepared statement at the specified index.","ref":"educkdb.html#bind_uint32/3"},{"type":"function","title":"educkdb.bind_uint64/3","doc":"Bind an uint64 to the prepared statement at the specified index.","ref":"educkdb.html#bind_uint64/3"},{"type":"function","title":"educkdb.bind_varchar/3","doc":"Bind a iolist as varchar to the prepared statement at the specified index. Note: This function is meant to bind null terminated strings in the database. Not arbitrary binary data.","ref":"educkdb.html#bind_varchar/3"},{"type":"function","title":"educkdb.chunk_column_count/1","doc":"Return the number of columns in the data chunk.","ref":"educkdb.html#chunk_column_count/1"},{"type":"function","title":"educkdb.chunk_column_types/1","doc":"Get the column types of the chunk [todo] spec..","ref":"educkdb.html#chunk_column_types/1"},{"type":"function","title":"educkdb.chunk_columns/1","doc":"Get the columns data of the chunk [todo] spec","ref":"educkdb.html#chunk_columns/1"},{"type":"function","title":"educkdb.chunk_size/1","doc":"Return the number of tuples in th data chunk.","ref":"educkdb.html#chunk_size/1"},{"type":"function","title":"educkdb.clear_bindings/1","doc":"Return the parameter type of the prepared statement at the specified index.","ref":"educkdb.html#clear_bindings/1"},{"type":"function","title":"educkdb.close/1","doc":"Close the database. All open connections will become unusable.","ref":"educkdb.html#close/1"},{"type":"function","title":"educkdb.column_names/1","doc":"Get the column names from the query result.","ref":"educkdb.html#column_names/1"},{"type":"function","title":"educkdb.config_flag_info/0","doc":"Return a map with config flags, and explanations. The options can vary depending on the underlying DuckDB version used. For more information about DuckDB configuration options, see: DuckDB Configuration .","ref":"educkdb.html#config_flag_info/0"},{"type":"function","title":"educkdb.connect/1","doc":"Connect to the database. Note: It is adviced to use the connection in a single process.","ref":"educkdb.html#connect/1"},{"type":"function","title":"educkdb.disconnect/1","doc":"Disconnect from the database.","ref":"educkdb.html#disconnect/1"},{"type":"function","title":"educkdb.execute/1","doc":"Execute a prepared statement, and retrieve the first result from the first data chunk.","ref":"educkdb.html#execute/1"},{"type":"function","title":"educkdb.execute_prepared/1","doc":"Execute a prepared statement. The answer is returned.","ref":"educkdb.html#execute_prepared/1"},{"type":"function","title":"educkdb.fetch_chunk/1","doc":"Fetches a data chunk from a result. The function should be called repeatedly until the result is exhausted.","ref":"educkdb.html#fetch_chunk/1"},{"type":"function","title":"educkdb.get_chunks/1","doc":"Get all data chunks from a query result.","ref":"educkdb.html#get_chunks/1"},{"type":"function","title":"educkdb.hugeint_to_integer/1","doc":"Convert a duckdb hugeint record to an erlang integer.","ref":"educkdb.html#hugeint_to_integer/1"},{"type":"function","title":"educkdb.integer_to_hugeint/1","doc":"Convert an erlang integer to a DuckDB hugeint. For more information on DuckDB numeric types: See DuckDB Numeric Data Types .","ref":"educkdb.html#integer_to_hugeint/1"},{"type":"function","title":"educkdb.integer_to_uhugeint/1","doc":null,"ref":"educkdb.html#integer_to_uhugeint/1"},{"type":"function","title":"educkdb.open/1","doc":"Open, or create a duckdb database with default options.","ref":"educkdb.html#open/1"},{"type":"function","title":"educkdb.open/2","doc":"Open, or create a duckdb file","ref":"educkdb.html#open/2"},{"type":"function","title":"educkdb.parameter_count/1","doc":"Return the number of parameters in a prepared statement.","ref":"educkdb.html#parameter_count/1"},{"type":"function","title":"educkdb.parameter_index/2","doc":null,"ref":"educkdb.html#parameter_index/2"},{"type":"function","title":"educkdb.parameter_name/2","doc":"Return the parameter name of the prepared statement at the specified index.","ref":"educkdb.html#parameter_name/2"},{"type":"function","title":"educkdb.parameter_type/2","doc":"Return the parameter type of the prepared statement at the specified index.","ref":"educkdb.html#parameter_type/2"},{"type":"function","title":"educkdb.prepare/2","doc":"Compile, and prepare a statement for later execution.","ref":"educkdb.html#prepare/2"},{"type":"function","title":"educkdb.query/2","doc":"Query the database. The answer the answer is returned immediately.","ref":"educkdb.html#query/2"},{"type":"function","title":"educkdb.result_extract/1","doc":null,"ref":"educkdb.html#result_extract/1"},{"type":"function","title":"educkdb.squery/2","doc":"Do a simple sql query without parameters, and retrieve the result from the first data chunk.","ref":"educkdb.html#squery/2"},{"type":"function","title":"educkdb.statement_type/1","doc":"Return the statement type of a prepared statement.","ref":"educkdb.html#statement_type/1"},{"type":"function","title":"educkdb.uhugeint_to_integer/1","doc":"Convert a duckdb uhugeint record to an erlang integer.","ref":"educkdb.html#uhugeint_to_integer/1"},{"type":"function","title":"educkdb.uuid_binary_to_uuid_string/1","doc":"Convert a binary represented UUID to a printable hex representation.","ref":"educkdb.html#uuid_binary_to_uuid_string/1"},{"type":"function","title":"educkdb.uuid_string_to_uuid_binary/1","doc":"Convert a printable UUID to a binary representation.","ref":"educkdb.html#uuid_string_to_uuid_binary/1"},{"type":"type","title":"educkdb.append_response/0","doc":null,"ref":"educkdb.html#t:append_response/0"},{"type":"type","title":"educkdb.appender/0","doc":null,"ref":"educkdb.html#t:appender/0"},{"type":"type","title":"educkdb.bind_response/0","doc":null,"ref":"educkdb.html#t:bind_response/0"},{"type":"type","title":"educkdb.connection/0","doc":null,"ref":"educkdb.html#t:connection/0"},{"type":"type","title":"educkdb.data/0","doc":null,"ref":"educkdb.html#t:data/0"},{"type":"type","title":"educkdb.data_chunk/0","doc":null,"ref":"educkdb.html#t:data_chunk/0"},{"type":"type","title":"educkdb.database/0","doc":null,"ref":"educkdb.html#t:database/0"},{"type":"type","title":"educkdb.datetime/0","doc":null,"ref":"educkdb.html#t:datetime/0"},{"type":"type","title":"educkdb.hugeint/0","doc":"struct, making up a 128 bit signed integer.","ref":"educkdb.html#t:hugeint/0"},{"type":"type","title":"educkdb.idx/0","doc":"DuckDB index type","ref":"educkdb.html#t:idx/0"},{"type":"type","title":"educkdb.int8/0","doc":"DuckDB tinyint","ref":"educkdb.html#t:int8/0"},{"type":"type","title":"educkdb.int16/0","doc":"DuckDB shortint","ref":"educkdb.html#t:int16/0"},{"type":"type","title":"educkdb.int32/0","doc":"DuckDB integer","ref":"educkdb.html#t:int32/0"},{"type":"type","title":"educkdb.int64/0","doc":"DuckDB bigint","ref":"educkdb.html#t:int64/0"},{"type":"type","title":"educkdb.named_column/0","doc":null,"ref":"educkdb.html#t:named_column/0"},{"type":"type","title":"educkdb.prepared_statement/0","doc":null,"ref":"educkdb.html#t:prepared_statement/0"},{"type":"type","title":"educkdb.result/0","doc":null,"ref":"educkdb.html#t:result/0"},{"type":"type","title":"educkdb.second/0","doc":"In the range 0.0..60.0","ref":"educkdb.html#t:second/0"},{"type":"type","title":"educkdb.sql/0","doc":null,"ref":"educkdb.html#t:sql/0"},{"type":"type","title":"educkdb.statement_type/0","doc":null,"ref":"educkdb.html#t:statement_type/0"},{"type":"type","title":"educkdb.time/0","doc":null,"ref":"educkdb.html#t:time/0"},{"type":"type","title":"educkdb.type_name/0","doc":"Note: decimal, timestamp_s, timestamp_ms, timestamp_ns and interval's are not supported yet.","ref":"educkdb.html#t:type_name/0"},{"type":"type","title":"educkdb.uhugeint/0","doc":"struct, making up a 128 bit unsigned integer.","ref":"educkdb.html#t:uhugeint/0"},{"type":"type","title":"educkdb.uint8/0","doc":"DuckDB duckdb utinyint","ref":"educkdb.html#t:uint8/0"},{"type":"type","title":"educkdb.uint16/0","doc":"DuckDB ushortint","ref":"educkdb.html#t:uint16/0"},{"type":"type","title":"educkdb.uint32/0","doc":"DuckDB uinteger","ref":"educkdb.html#t:uint32/0"},{"type":"type","title":"educkdb.uint64/0","doc":"DuckDB ubigint","ref":"educkdb.html#t:uint64/0"},{"type":"extras","title":"educkdb","doc":"# educkdb\n\n[![Hex.pm version](https://img.shields.io/hexpm/v/educkdb.svg)](https://hex.pm/packages/educkdb)\n[![Hex.pm downloads](https://img.shields.io/hexpm/dt/educkdb.svg)](https://hex.pm/packages/educkdb)\n[![Test](https://github.com/mmzeeman/educkdb/actions/workflows/test.yml/badge.svg)](https://github.com/mmzeeman/educkdb/actions/workflows/test.yml)\n\nDuckDB NIF for Erlang. \n\nDuckDB (https://duckdb.org/) is an in-process SQL OLAP database management system. This library makes it possible to \nuse DuckDB in Erlang, Elixir or other languages supported by the beam.\n\n# Example\n\nConnect to a database\n\n```erlang\n\n{ok, Db} = educkdb:open(\"database.db\"),\n{ok, Conn} = educkdb:connect(Db)\n...\n```\n\nCreate a table by reading a CSV or parquet files.\n\n```erlang\n\n{ok, _} = educkdb:query(Conn, \"CREATE TABLE ontime AS SELECT * FROM 'test.csv'\"),\n{ok, ParquetData} = educkdb:query(Conn, \"SELECT * FROM 'test.parquet'\"),\n...\n```\n\n\n# API\n\n*Note: This is a work in progress. At the moment it is possible to open, connect, query and return integer and\nvarchar results. The nif function returning the query result will become a yielding nif. This is important for\nlarge query results.*\n\n#","ref":"readme.html"},{"type":"extras","title":"Startup - educkdb","doc":"#### `open(filename, options)` -> `{ok, DB}` | `{error, msg}` \n\nNote: (**dirty scheduler**) \n\n#### `connect(db)` -> `{ok, Conn}` | `{error, msg}`\n\nNote, creates a nif thread with a command queue, all calls which uses the \nconnection as parameter will be send to the thread via the queue.\n\n#### `disconnect(connection)` -> `ok` | `{error, msg}`\n\nNote: **via command thread**.\n\nExplicitly disconnect the connection. This also explicitly finalizes the thread.\nIt is not required to call this. The garbage collector will disconnection \nautomatically.\n\n#### `close(db)` -> `ok` | `{error, msg}`\n\nNote: (**dirty scheduler**)\n\nExplicitly close the db. It is not required to call this. The garbage collector \nwill disconnection automatically.\n\n#","ref":"readme.html#startup"},{"type":"extras","title":"Querying - educkdb","doc":"#### `query(Conn, Query)` -> `{ok, QueryResult}` | `{error, msg}`\n\nNote: **dirty scheduler**\n\nRun a query, return the result.\n\n#","ref":"readme.html#querying"},{"type":"extras","title":"Prepared Statements - educkdb","doc":"#### `prepare(Conn, Query)` -> `{ok, Stmt}` | `{error, _}`\n\nNote: **dirty scheduler**\n\n#### `bind(Stmt, Values)` -> `ok` | `{error, _}`\n\nNote: **direct c**\n\n#### `bind_null(Stmt, Index, Value)` -> `ok` | `error`\nNote: **direct c**\n\n#### `bind_boolean(Stmt, Index, Value)` -> `ok` | `error`\nNote: **direct c**\n\n#### `bind_int8(Stmt, Index, Value)` -> `ok` | `error`\nNote: **direct c**\n\n#### `bind_int16(Stmt, Index, Value)` -> `ok` | `error`\nNote: **direct c**\n\n#### `bind_int32(Stmt, Index, Value)` -> `ok` | `error`\nNote: **direct c**\n\n#### `bind_int64(Stmt, Index, Value)` -> `ok` | `error`\nNote: **direct c**\n\n#### `bind_hugeint(Stmt, Index, Value)` -> `ok` | `error`\nNote: **direct c**\n\n#### `bind_uint8(Stmt, Index, Value)` -> `ok` | `error`\nNote: **direct c**\n\n#### `bind_uint16(Stmt, Index, Value)` -> `ok` | `error`\nNote: **direct c**\n\n#### `bind_uint32(Stmt, Index, Value)` -> `ok` | `error`\nNote: **direct c**\n\n#### `bind_uint64(Stmt, Index, Value)` -> `ok` | `error`\nNote: **direct c**\n\n#### `bind_float(Stmt, Index, Value)` -> `ok` | `error`\nNote: **direct c**\n\n#### `bind_double(Stmt, Index, Value)` -> `ok` | `error`\nNote: **direct c**\n\n#### `bind_date(Stmt, Index, Value)` -> `ok` | `error`\nNote: **direct c**\n\n#### `bind_time(Stmt, Index, Value)` -> `ok` | `error`\nNote: **direct c**\n\n#### `bind_timestamp(Stmt, Index, Value)` -> `ok` | `error`\nNote: **direct c**\n\n#### `....more`\n\n#### `execute_statement(Stmt)` -> `{ok, result()}` | `{error, _}`\n\nNote: **dirty thread**\n\n### `appender`\n\n####","ref":"readme.html#prepared-statements"},{"type":"extras","title":"Implementation notes - educkdb","doc":"* https://potatosalad.io/2017/08/05/latency-of-native-functions-for-erlang-and-elixir\n * https://github.com/vinoski/bitwise","ref":"readme.html#implementation-notes"},{"type":"extras","title":"LICENSE","doc":"Apache License\n                        Version 2.0, January 2004\n                     http://www.apache.org/licenses/\n\nTERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n1. Definitions.\n\n   \"License\" shall mean the terms and conditions for use, reproduction,\n   and distribution as defined by Sections 1 through 9 of this document.\n\n   \"Licensor\" shall mean the copyright owner or entity authorized by\n   the copyright owner that is granting the License.\n\n   \"Legal Entity\" shall mean the union of the acting entity and all\n   other entities that control, are controlled by, or are under common\n   control with that entity. For the purposes of this definition,\n   \"control\" means (i) the power, direct or indirect, to cause the\n   direction or management of such entity, whether by contract or\n   otherwise, or (ii) ownership of fifty percent (50%) or more of the\n   outstanding shares, or (iii) beneficial ownership of such entity.\n\n   \"You\" (or \"Your\") shall mean an individual or Legal Entity\n   exercising permissions granted by this License.\n\n   \"Source\" form shall mean the preferred form for making modifications,\n   including but not limited to software source code, documentation\n   source, and configuration files.\n\n   \"Object\" form shall mean any form resulting from mechanical\n   transformation or translation of a Source form, including but\n   not limited to compiled object code, generated documentation,\n   and conversions to other media types.\n\n   \"Work\" shall mean the work of authorship, whether in Source or\n   Object form, made available under the License, as indicated by a\n   copyright notice that is included in or attached to the work\n   (an example is provided in the Appendix below).\n\n   \"Derivative Works\" shall mean any work, whether in Source or Object\n   form, that is based on (or derived from) the Work and for which the\n   editorial revisions, annotations, elaborations, or other modifications\n   represent, as a whole, an original work of authorship. For the purposes\n   of this License, Derivative Works shall not include works that remain\n   separable from, or merely link (or bind by name) to the interfaces of,\n   the Work and Derivative Works thereof.\n\n   \"Contribution\" shall mean any work of authorship, including\n   the original version of the Work and any modifications or additions\n   to that Work or Derivative Works thereof, that is intentionally\n   submitted to Licensor for inclusion in the Work by the copyright owner\n   or by an individual or Legal Entity authorized to submit on behalf of\n   the copyright owner. For the purposes of this definition, \"submitted\"\n   means any form of electronic, verbal, or written communication sent\n   to the Licensor or its representatives, including but not limited to\n   communication on electronic mailing lists, source code control systems,\n   and issue tracking systems that are managed by, or on behalf of, the\n   Licensor for the purpose of discussing and improving the Work, but\n   excluding communication that is conspicuously marked or otherwise\n   designated in writing by the copyright owner as \"Not a Contribution.\"\n\n   \"Contributor\" shall mean Licensor and any individual or Legal Entity\n   on behalf of whom a Contribution has been received by Licensor and\n   subsequently incorporated within the Work.\n\n2. Grant of Copyright License. Subject to the terms and conditions of\n   this License, each Contributor hereby grants to You a perpetual,\n   worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n   copyright license to reproduce, prepare Derivative Works of,\n   publicly display, publicly perform, sublicense, and distribute the\n   Work and such Derivative Works in Source or Object form.\n\n3. Grant of Patent License. Subject to the terms and conditions of\n   this License, each Contributor hereby grants to You a perpetual,\n   worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n   (except as stated in this section) patent license to make, have made,\n   use, offer to sell, sell, import, and otherwise transfer the Work,\n   where such license applies only to those patent claims licensable\n   by such Contributor that are necessarily infringed by their\n   Contribution(s) alone or by combination of their Contribution(s)\n   with the Work to which such Contribution(s) was submitted. If You\n   institute patent litigation against any entity (including a\n   cross-claim or counterclaim in a lawsuit) alleging that the Work\n   or a Contribution incorporated within the Work constitutes direct\n   or contributory patent infringement, then any patent licenses\n   granted to You under this License for that Work shall terminate\n   as of the date such litigation is filed.\n\n4. Redistribution. You may reproduce and distribute copies of the\n   Work or Derivative Works thereof in any medium, with or without\n   modifications, and in Source or Object form, provided that You\n   meet the following conditions:\n\n   (a) You must give any other recipients of the Work or\n       Derivative Works a copy of this License; and\n\n   (b) You must cause any modified files to carry prominent notices\n       stating that You changed the files; and\n\n   (c) You must retain, in the Source form of any Derivative Works\n       that You distribute, all copyright, patent, trademark, and\n       attribution notices from the Source form of the Work,\n       excluding those notices that do not pertain to any part of\n       the Derivative Works; and\n\n   (d) If the Work includes a \"NOTICE\" text file as part of its\n       distribution, then any Derivative Works that You distribute must\n       include a readable copy of the attribution notices contained\n       within such NOTICE file, excluding those notices that do not\n       pertain to any part of the Derivative Works, in at least one\n       of the following places: within a NOTICE text file distributed\n       as part of the Derivative Works; within the Source form or\n       documentation, if provided along with the Derivative Works; or,\n       within a display generated by the Derivative Works, if and\n       wherever such third-party notices normally appear. The contents\n       of the NOTICE file are for informational purposes only and\n       do not modify the License. You may add Your own attribution\n       notices within Derivative Works that You distribute, alongside\n       or as an addendum to the NOTICE text from the Work, provided\n       that such additional attribution notices cannot be construed\n       as modifying the License.\n\n   You may add Your own copyright statement to Your modifications and\n   may provide additional or different license terms and conditions\n   for use, reproduction, or distribution of Your modifications, or\n   for any such Derivative Works as a whole, provided Your use,\n   reproduction, and distribution of the Work otherwise complies with\n   the conditions stated in this License.\n\n5. Submission of Contributions. Unless You explicitly state otherwise,\n   any Contribution intentionally submitted for inclusion in the Work\n   by You to the Licensor shall be under the terms and conditions of\n   this License, without any additional terms or conditions.\n   Notwithstanding the above, nothing herein shall supersede or modify\n   the terms of any separate license agreement you may have executed\n   with Licensor regarding such Contributions.\n\n6. Trademarks. This License does not grant permission to use the trade\n   names, trademarks, service marks, or product names of the Licensor,\n   except as required for reasonable and customary use in describing the\n   origin of the Work and reproducing the content of the NOTICE file.\n\n7. Disclaimer of Warranty. Unless required by applicable law or\n   agreed to in writing, Licensor provides the Work (and each\n   Contributor provides its Contributions) on an \"AS IS\" BASIS,\n   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n   implied, including, without limitation, any warranties or conditions\n   of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n   PARTICULAR PURPOSE. You are solely responsible for determining the\n   appropriateness of using or redistributing the Work and assume any\n   risks associated with Your exercise of permissions under this License.\n\n8. Limitation of Liability. In no event and under no legal theory,\n   whether in tort (including negligence), contract, or otherwise,\n   unless required by applicable law (such as deliberate and grossly\n   negligent acts) or agreed to in writing, shall any Contributor be\n   liable to You for damages, including any direct, indirect, special,\n   incidental, or consequential damages of any character arising as a\n   result of this License or out of the use or inability to use the\n   Work (including but not limited to damages for loss of goodwill,\n   work stoppage, computer failure or malfunction, or any and all\n   other commercial damages or losses), even if such Contributor\n   has been advised of the possibility of such damages.\n\n9. Accepting Warranty or Additional Liability. While redistributing\n   the Work or Derivative Works thereof, You may choose to offer,\n   and charge a fee for, acceptance of support, warranty, indemnity,\n   or other liability obligations and/or rights consistent with this\n   License. However, in accepting such obligations, You may act only\n   on Your own behalf and on Your sole responsibility, not on behalf\n   of any other Contributor, and only if You agree to indemnify,\n   defend, and hold each Contributor harmless for any liability\n   incurred by, or claims asserted against, such Contributor by reason\n   of your accepting any such warranty or additional liability.\n\nEND OF TERMS AND CONDITIONS\n\nAPPENDIX: How to apply the Apache License to your work.\n\n   To apply the Apache License to your work, attach the following\n   boilerplate notice, with the fields enclosed by brackets \"[]\"\n   replaced with your own identifying information. (Don't include\n   the brackets!)  The text should be enclosed in the appropriate\n   comment syntax for the file format. We also recommend that a\n   file or class name and description of purpose be included on the\n   same \"printed page\" as the copyright notice for easier\n   identification within third-party archives.\n\nCopyright [yyyy] [name of copyright owner]\n\nLicensed under the Apache License, Version 2.0 (the \"License\");\nyou may not use this file except in compliance with the License.\nYou may obtain a copy of the License at\n\n    http://www.apache.org/licenses/LICENSE-2.0\n\nUnless required by applicable law or agreed to in writing, software\ndistributed under the License is distributed on an \"AS IS\" BASIS,\nWITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\nSee the License for the specific language governing permissions and\nlimitations under the License.","ref":"license.html"}],"content_type":"text/plain"}